do

    local oldModBlueprints = ModBlueprints

    function ModBlueprints(all_bps)
        oldModBlueprints(all_bps)

        local multFactor = nil

        local noArcMultiplier = 3.0
        local lowArcMultiplier = 2.0
        local highArcMultiplier = math.sqrt(2.0) -- should go twice (2x) as far now.

        for id, bp in all_bps.Unit do

            if bp.Weapon then

                for ik, wep in bp.Weapon do

                    if wep.MuzzleVelocity then

                        if wep.BallisticArc == 'RULEUBA_None' then
                            multFactor = noArcMultiplier

                        end

                        if wep.BallisticArc == 'RULEUBA_LowArc' then
                            multFactor = lowArcMultiplier

                        end

                        if wep.BallisticArc == 'RULEUBA_HighArc' then 
                            multFactor = highArcMultiplier

                        end

                      # increase the projectile velocities by respective amounts.
                        wep.MuzzleVelocity = wep.MuzzleVelocity * multFactor

                      # tweak the projectile lifetime accordingly, so it doesn't fly off to china.
                        if wep.ProjectileLifetime then

                            if wep.BallisticArc == 'RULEUBA_HighArc' then 
                                wep.ProjectileLifetime = wep.ProjectileLifetime * multFactor

                            else
                                wep.ProjectileLifetime = wep.ProjectileLifetime / multFactor

                            end

                        end

                    end

                end # bp.Weapon loop

            end

        end # all_bps.Unit loop

    end

end